Fixed sourcing of $PWD/rip_dvd.conf file if present
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index b83e060122f2fdc50bf7e6a187a1c4eadc3a1e47..ebcd87ff162d2e652ec0c60330d8e050534ea39c 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
 #
 
-##############################################################################
-# Local Machine Settings:
-# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
-# and the local conf file created by each local machine (rip_dvd.conf)
-# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
-# This will allow you to override all the default values to meet your needs
-# in a way that won't get clobbered when you pull updates from my GIT repo.
-##############################################################################
-config="${0%/*}/rip_dvd.conf"
-[ -e "${config}.dist" ] && . ${config}.dist
-[ -e "${config}" ] && . ${config}
-
 ##############################################################################################
-# Command line processing
+# Global Variables
 ##############################################################################################
+typeset cmd="$0 $*"
 typeset dvdname=""
 typeset debug=""
 typeset dest=""
@@ -49,8 +38,11 @@ typeset dvdpath=""
 typeset aspect=""
 typeset SCALE=""
 typeset CROP=""
-typeset profile="xvid"
+typeset profile="xvidvhq"
 typeset extension=""
+typeset mailto=""
+typeset -i force_onepass_mode=0
+typeset -i eject_disk=1
 typeset -i keep_isofile=0
 typeset -i keep_vobfile=0
 typeset -i keep_dvdfolder=0
@@ -62,14 +54,48 @@ typeset -i make_final_dest_comp=0
 typeset -i errors=0
 typeset -i show_usage=0
 typeset -i mirror_mode=0
-typeset -i target_bitrate=0
+typeset -i target_bitrate=2000
 typeset -i target_size=0
 typeset -i audio_2ch=0
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
 
-while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a:p:e: opt "$@"
+##############################################################################
+# Local Machine Settings:
+# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
+# and the local conf file created by each local machine (rip_dvd.conf)
+# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
+# This will allow you to override all the default values to meet your needs
+# in a way that won't get clobbered when you pull updates from my GIT repo.
+##############################################################################
+config="${0%/*}/rip_dvd.conf"
+
+# The config file will be searched for in the following location order:
+found_config=0
+
+# 1) /path/to/rip_dvd/script/rip_dvd.conf.dist
+[ -e "${config}.dist" ] && found_config=1 && . "${config}.dist"
+
+# 2) /path/to/rip_dvd/script/rip_dvd.conf
+[ -e "${config}" ] && found_config=1 && . "${config}"
+
+# 3) /etc/rip_dvd.conf
+[ -e "/etc/rip_dvd.conf" ] && found_config=1 && . "/etc/rip_dvd.conf"
+
+# 4) $PWD/rip_dvd.conf
+[ -e "$PWD/rip_dvd.conf" ] && found_config=1 && . "$PWD/rip_dvd.conf"
+
+# Check to make sure we found the config file
+if [ $found_config -eq 0 ]; then
+  echo "-E- Unable to find the rip_dvd.conf file: $config"
+  exit 1
+fi
+
+##############################################################################################
+# Command line processing
+##############################################################################################
+while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
@@ -77,6 +103,7 @@ do
         (b)     target_bitrate=$OPTARG;;
        (s)     target_size=$OPTARG;;
         (2)     audio_2ch=1;;
+        (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
         (f)     make_final_dest_folder=1;; 
@@ -87,6 +114,7 @@ do
        (a)     aspect=$OPTARG;;
        (p)     profile=$OPTARG;;
        (e)     extension=$OPTARG;;
+       (j)     eject_disk=$OPTARG;;
         (w)     set -$opt;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
@@ -103,17 +131,18 @@ function usage() {
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
-    echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
-    echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 2) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 3) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 4) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
-    echo >&2 "                 - xvid = AVI, Xvid codec, 2 pass encoding, original aspect, no scaling (default)"
-    echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding, original aspect, no scaling"
-    echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, 480:320 scaling"
-    echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, 320:240 scaling"
+    echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
+    echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
+    echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
+    #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
+    #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
+    #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
+    echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
+    echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
@@ -129,6 +158,12 @@ function usage() {
     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
+    echo >&2 "   -j <n>        Eject the disk:"
+    echo >&2 "                 - 0 = do not eject the disk"
+    echo >&2 "                 - 1 = eject after the entire script is done (default)"
+    echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
+    echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
+    echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
@@ -150,8 +185,8 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
-  echo "-E- You can't specify a bitrate, target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
+if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
+  echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
@@ -204,6 +239,7 @@ fi
 
 typeset -i ripdvd
 if [ -z "$dvdname" ]; then
+
   # make sure the DVD device is accessible
   volname $dev > /dev/null 2>&1
   if [ $? != 0 ]; then
@@ -213,7 +249,9 @@ if [ -z "$dvdname" ]; then
   # now capture the volume name from the device
   dvdname=`volname $dev | awk '{ print $1 }'`
   ripdvd=1
+
 else 
+
   # check to see if dvdname is a full path to a real directory
   # if it is, set dvdname and dvdpath appropriately
   if [ -d "$dvdname" ]; then
@@ -248,7 +286,7 @@ else
 
     # check to see if dvdname is a full path to an ISO file
     # if it is, set dvdname and isofile appropriately
-    file "$dvdname" | grep -q "ISO"
+    file "$dvdname" | grep -q -e "ISO" -e "UDF"
     if [ $? == 0 ]; then
       # It is a valid ISO file, now strip the extension off our dvdname
       isofile="$dvdname"
@@ -263,8 +301,19 @@ else
       echo "-E- Unsupported file type: $vobfile"
       exit 1
     fi
+
+  # Throw an error if we can't find what the -n option is pointing to
+  else 
+    echo "-E- Unable to find the directory or file specified by the '-n $dvdname' option. Please make sure the path is valid."
+    exit 1
   fi
+
+  # Set the ripdvd flag to false since we aren't ripping a DVD disk
   ripdvd=0
+
+  # Since we aren't ripping a DVD disk, don't eject anything either
+  eject_disk=0
+
 fi
 
 # remove bad characters from the dvdname
@@ -341,6 +390,7 @@ fatal_and_exit() {
   if [[ -n "$mailto" ]]; then
     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
   fi
+  keep_intermediate_files=1
   exit 1
 }
 
@@ -351,6 +401,237 @@ trap cleanup EXIT
 ##############################################################################################
 # processing functions
 ##############################################################################################
+
+# encode the vob file into a compressed file format
+function encode_vob_file {
+
+  # Set a variable that we will use later to determine if we found a handler for $profile or not
+  typeset -i found_profile=0
+
+  # For a given profile, to override the 2 pass behavior to be single pass,
+  # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
+  # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
+  PASSES="1 2"
+
+  # Declare our default 2 pass variables
+  passlogfile_opt="-passlogfile $passlogfile"
+  pass_opt="pass=%PASS"
+
+  # Check the global force_onepass_mode. If it is set, change our variables appropriately
+  # to force 1-pass encoding across all profiles.
+  if [ $force_onepass_mode -eq 1 ]; then
+    PASSES="2"
+    passlogfile_opt=""
+    pass_opt=""    
+  fi
+
+  # XVID profile
+  if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
+    found_profile=1
+    final_output_file="$dest/$dvdname.avi"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
+    mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
+    mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
+    mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
+
+    # Very High Quality (16fps)
+    if [ "$profile" == "xvidvhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=4"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # High Quality (20fps)
+    if [ "$profile" == "xvidhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="chroma_opt"
+      video_encoder_opts[3]="vhq=2"
+      video_encoder_opts[4]="bvhq=1"
+      video_encoder_opts[5]="quant_type=mpeg"
+      video_encoder_opts[6]="autoaspect"
+    fi
+    # Fast (28fps)
+    if [ "$profile" == "xvid" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="vhq=0"
+      video_encoder_opts[3]="turbo"
+      video_encoder_opts[4]="autoaspect"
+    fi
+
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    if [ $audio_2ch -eq 0 ]; then
+      # These options produce good 6 channel audio for linux and windows
+      mencoder_audio_opts="-oac copy"
+      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+      mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+      mencoder_audioch_opts[1]="-af channels=6"
+      mencoder_audioch_opts[2]=""
+    else
+      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      mencoder_audioch_opts[0]=""
+    fi
+  fi
+
+  # MP4 encoding profiles
+  # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
+  if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
+    found_profile=1
+    final_output_file="$dest/$dvdname.mp4"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
+    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
+    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
+
+    # Very High Quality (6fps)
+    if [ "$profile" == "mp4vhq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=6"
+      video_encoder_opts[3]="frameref=5"
+      video_encoder_opts[4]="bframes=3"
+      video_encoder_opts[5]="8x8dct"
+      video_encoder_opts[6]="me=umh"
+      video_encoder_opts[7]="b_pyramid"
+      video_encoder_opts[8]="weight_b"
+      video_encoder_opts[9]="partitions=all" 
+    fi
+    # High Quality (13fps)
+    if [ "$profile" == "mp4hq" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=5"
+      video_encoder_opts[3]="frameref=2"
+      video_encoder_opts[4]="bframes=3"
+      video_encoder_opts[5]="8x8dct"
+      video_encoder_opts[6]="b_pyramid"
+      video_encoder_opts[7]="weight_b"
+    fi
+    # Fast (17fps)
+    if [ "$profile" == "mp4" ]; then
+      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[1]="threads=$mencoder_threads"
+      video_encoder_opts[2]="subq=4"
+      video_encoder_opts[3]="bframes=2"
+      video_encoder_opts[4]="b_pyramid"
+      video_encoder_opts[5]="weight_b"
+    fi
+
+    for OPTS in "${video_encoder_opts[@]}"; do
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    if [ $audio_2ch -eq 0 ]; then
+      # These options produce good 6 channel audio for linux and windows
+      #mencoder_audio_opts="-oac copy"
+      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
+      #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
+      #mencoder_audioch_opts[1]="-af channels=6"
+      #mencoder_audioch_opts[2]=""
+      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+      mencoder_audioch_opts[0]="-channels 6 -srate 48000 -af volnorm=1"
+    else
+      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
+      #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      #mencoder_audioch_opts[0]=""
+      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+      mencoder_audioch_opts[0]="-channels 2 -srate 48000 -af volnorm=1"
+    fi
+
+  fi
+
+  # iphone and ipod MP4 profiles
+  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
+    found_profile=1
+    if [ "$profile" == "iphone" ]; then
+      # SCALE: 480x320
+      # scale width to 480, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=480:-10"
+      # scale the video down however far is necessary to fit in 480x320
+      SCALE=",dsize=480:320:0,scale=-8:-8"
+    else
+      # SCALE: 320x240
+      # scale width to 320, set height appropriately, but keep a multiple of 16
+      #SCALE=",scale=320:-10"
+      # scale the video down however far is necessary to fit in 320x240
+      SCALE=",dsize=320:240:0,scale=-8:-8"
+    fi
+    final_output_file="$dest/$dvdname.mp4"
+    mencoder_general_opts="$lang_opts $passlogfile_opt"
+    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
+    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
+    mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
+    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[1]="threads=$mencoder_threads"
+    video_encoder_opts[2]="vbv_maxrate=1500"
+    video_encoder_opts[3]="vbv_bufsize=2000"
+    video_encoder_opts[4]="nocabac"
+    video_encoder_opts[5]="me=umh"
+    video_encoder_opts[6]="subq=6"
+    video_encoder_opts[7]="frameref=6"
+    video_encoder_opts[8]="trellis=1"
+    video_encoder_opts[9]="level_idc=30"
+    video_encoder_opts[10]="global_header"
+    video_encoder_opts[11]="bframes=0"
+    video_encoder_opts[12]="partitions=all"
+    for OPTS in "${video_encoder_opts[@]}"; do 
+      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
+    done
+
+    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+    mencoder_audioch_opts[0]="-channels 2 -srate 48000"
+  fi
+
+  if [ $found_profile -eq 0 ]; then
+    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
+  fi
+
+  # Do not edit this line. $mencoder_video_encoder_opts must be last
+  mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
+  mencoder_retval=0
+
+  for PASS in $PASSES
+  do 
+    # Set some options based on which pass we are in
+    mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
+    [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
+    [ $PASS -eq 1 ] && output_file="/dev/null"
+    [ $PASS -eq 2 ] && output_file="$final_output_file"
+  
+    # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
+    for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
+    do
+      echo -e "   Encoding pass $PASS"
+      echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
+      mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
+      mencoder_retval=$? 
+      grep -q "\[channels\] Invalid" $encodelog
+      if [ $? != 0 ]; then         
+        break;
+      else
+        echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
+      fi
+    done
+      
+    if [ $mencoder_retval != 0 ]; then
+      fatal_and_exit "-E- Unhandled mencoder error"
+    fi
+
+    # Concatenate the encode log to our main log file, greping out unwanted lines
+    cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
+
+  done
+}
+
 function make_dvd_iso_image {
 
   isofile="$1"
@@ -543,7 +824,8 @@ function get_crop_from_iso {
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
-    fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
   fi
   if [ $CROPCHECK -lt 0 ]; then 
     CROP=""
@@ -567,7 +849,8 @@ function get_crop_from_vob {
   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
   if [ -z "$CROP" ]; then
-    fatal_and_exit "-E- Unable to extract CROP value from iso: $isofile"
+    echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
+    return
   fi
   if [ $CROPCHECK -lt 0 ]; then 
     CROP=""
@@ -809,193 +1092,6 @@ function check_for_mplayer_dumpstream_incompatibility {
   fi
 }
 
-# encode the vob file into a compressed file format
-function compress_vob_file {
-  typeset -i found_profile=0
-   
-  # XVID profile
-  if [ "$profile" == "xvid" ]; then
-    found_profile=1
-    final_output_file="$dest/$dvdname.avi"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-    mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
-    mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
-    mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
-    video_encoder_opts[1]="threads=$mencoder_threads"
-    video_encoder_opts[2]="chroma_opt"
-    video_encoder_opts[3]="vhq=4"
-    video_encoder_opts[4]="bvhq=1"
-    video_encoder_opts[5]="quant_type=mpeg"
-    video_encoder_opts[6]="autoaspect"
-    for OPTS in "${video_encoder_opts[@]}"; do 
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    if [ $audio_2ch -eq 0 ]; then
-      # These options produce good 6 channel audio for linux and windows
-      mencoder_audio_opts="-oac copy"
-      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
-      mencoder_audioch_opts[0]="-channels 6 -af channels=6"
-      mencoder_audioch_opts[1]="-af channels=6"
-      mencoder_audioch_opts[2]=""
-    else
-      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
-      mencoder_audioch_opts[0]=""
-    fi
-  fi
-
-  # MP4 encoding profiles
-  if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
-    found_profile=1
-    final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
-    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
-
-    # Very High Quality (6fps)
-    if [ "$profile" == "mp4vhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=6"
-      video_encoder_opts[3]="frameref=5"
-      video_encoder_opts[4]="bframes=3"
-      video_encoder_opts[5]="8x8dct"
-      video_encoder_opts[6]="me=umh"
-      video_encoder_opts[7]="b_pyramid"
-      video_encoder_opts[8]="weight_b"
-      video_encoder_opts[9]="partitions=all" 
-    fi
-    # High Quality (13fps)
-    if [ "$profile" == "mp4hq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=5"
-      video_encoder_opts[3]="frameref=2"
-      video_encoder_opts[4]="bframes=3"
-      video_encoder_opts[5]="8x8dct"
-      video_encoder_opts[6]="b_pyramid"
-      video_encoder_opts[7]="weight_b"
-    fi
-    # Fast
-    if [ "$profile" == "mp4hq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
-      video_encoder_opts[1]="threads=$mencoder_threads"
-      video_encoder_opts[2]="subq=4"
-      video_encoder_opts[3]="bframes=2"
-      video_encoder_opts[4]="b_pyramid"
-      video_encoder_opts[5]="weight_b"
-    fi
-
-    for OPTS in "${video_encoder_opts[@]}"; do
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    if [ $audio_2ch -eq 0 ]; then
-      # These options produce good 6 channel audio for linux and windows
-      #mencoder_audio_opts="-oac copy"
-      # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
-      #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
-      #mencoder_audioch_opts[1]="-af channels=6"
-      #mencoder_audioch_opts[2]=""
-      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 6 -srate 48000"
-    else
-      # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
-      #mencoder_audioch_opts[0]=""
-      mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-      mencoder_audioch_opts[0]="-channels 2 -srate 48000"
-    fi
-
-  fi
-
-  # iphone and ipod MP4 profiles
-  if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
-    found_profile=1
-    if [ "$profile" == "iphone" ]; then
-      # SCALE: 480x320
-      # scale width to 480, set height appropriately, but keep a multiple of 16
-      #SCALE=",scale=480:-10"
-      # scale the video down however far is necessary to fit in 480x320
-      SCALE=",dsize=480:320:0,scale=-8:-8"
-    else
-      # SCALE: 320x240
-      # scale width to 320, set height appropriately, but keep a multiple of 16
-      #SCALE=",scale=320:-10"
-      # scale the video down however far is necessary to fit in 320x240
-      SCALE=",dsize=320:240:0,scale=-8:-8"
-    fi
-    final_output_file="$dest/$dvdname.mp4"
-    mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
-    mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
-    mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
-    mencoder_video_encoder_opts="-ovc x264 -x264encopts pass=%PASS"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
-    video_encoder_opts[1]="threads=$mencoder_threads"
-    video_encoder_opts[2]="vbv_maxrate=1500"
-    video_encoder_opts[3]="vbv_bufsize=2000"
-    video_encoder_opts[4]="nocabac"
-    video_encoder_opts[5]="me=umh"
-    video_encoder_opts[6]="subq=6"
-    video_encoder_opts[7]="frameref=6"
-    video_encoder_opts[8]="trellis=1"
-    video_encoder_opts[9]="level_idc=30"
-    video_encoder_opts[10]="global_header"
-    video_encoder_opts[11]="bframes=0"
-    video_encoder_opts[12]="partitions=all"
-    for OPTS in "${video_encoder_opts[@]}"; do 
-      mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
-    done
-
-    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
-    mencoder_audioch_opts[0]="-channels 2 -srate 48000"
-  fi
-
-  if [ $found_profile -eq 0 ]; then
-    fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
-  fi
-
-  # Do not edit this line. $mencoder_video_encoder_opts must be last
-  mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
-  mencoder_retval=0
-
-  for PASS in 1 2 
-  do 
-    # Set some options based on which pass we are in
-    mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
-    [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
-    [ $PASS -eq 1 ] && output_file="/dev/null"
-    [ $PASS -eq 2 ] && output_file="$final_output_file"
-  
-    # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
-    for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
-    do
-      echo -e "   Encoding pass $PASS"
-      echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
-      mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
-      mencoder_retval=$? 
-      grep -q "\[channels\] Invalid" $encodelog
-      if [ $? != 0 ]; then         
-        break;
-      else
-        echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
-      fi
-    done
-      
-    if [ $mencoder_retval != 0 ]; then
-      fatal_and_exit "-E- Unhandled mencoder error"
-    fi
-
-    # Concatenate the encode log to our main log file, greping out unwanted lines
-    cat $encodelog | grep -v "Pos:" >> "$logfile"
-
-  done
-}
-
 function fill_mythvideo_metadata {
 
   # This function must be passed the filename as an argument
@@ -1054,6 +1150,7 @@ function remove_intermediate_dvdbackup_folder {
 # Make a note of when this DVD rip started
 date=`date`
 echo -e "\n$date DVD rip started" >> "$logfile"
+echo "$cmd" >> "$logfile"
 
 # Rip the DVD - Mirror Mode
 if [ $mirror_mode -eq 1 ]; then
@@ -1066,7 +1163,9 @@ if [ $mirror_mode -eq 1 ]; then
   fill_mythvideo_metadata "$dest/$dvdname.iso" 
 
   # eject the disk upon completion
-  eject -T $dev
+  if [ $eject_disk -ne 0 ]; then
+    eject -T $dev
+  fi
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"
@@ -1169,6 +1268,9 @@ if [ $mirror_mode -eq 0 ]; then
       get_crop_from_vob
     fi
 
+    # eject the DVD disk since we are finished with it
+    [ $eject_disk -eq 2 ] && eject -T $dev
+
     # encode the VOB file to a compressed file format
     if [ $make_final_dest_comp -eq 1 ]; then
       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
@@ -1177,7 +1279,7 @@ if [ $mirror_mode -eq 0 ]; then
       calculate_bitrate_from_target_size        
      
       # encode the vob file into a compressed file format
-      compress_vob_file
+      encode_vob_file
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
@@ -1248,7 +1350,7 @@ if [ $mirror_mode -eq 0 ]; then
   remove_intermediate_dvdbackup_folder
 
   # eject the DVD disk upon completion
-  [ $ripdvd -eq 1 ] && eject -T $dev
+  [ $eject_disk -eq 1 ] && eject -T $dev
 
   date=`date`
   echo "$date DVD rip completed" | tee -a "$logfile"
@@ -1259,4 +1361,4 @@ if [ $mirror_mode -eq 0 ]; then
 
 fi
 
-##############################################################################################
\ No newline at end of file
+##############################################################################################